Syncfusion Feedback

Trusted by the world’s leading companies

Syncfusion Trusted Companies

Overview

The React AutoComplete is a textbox component that provides a list of suggestions to select from as the user types. It has several out-of-the-box features such as data binding, filtering, grouping, UI customization, accessibility, and more.


React AutoComplete Code Example

Easily get started with the React AutoComplete using a few simple lines of TSX code example as demonstrated below. Also explore our React AutoComplete Example that shows you how to render and configure a AutoComplete in React.

/**
 * AutoComplete Default functionality Sample
 */
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { AutoCompleteComponent } from '@syncfusion/ej2-react-dropdowns';
import { SampleBase } from '../common/sample-base';
import { PropertyPane } from '../common/property-pane';
import './default.css';
import * as data from './dataSource.json';

export class Default extends SampleBase<{}, {}> {

  private listObj: AutoCompleteComponent;
  private temp:string = 'sportsData';
  // define the array of string
  private sportsData: string[] =data[this.temp];
  render() {
    return (
      <div id='combodefault' className='control-pane'>
        <div className='control-section'>
          <div className='col-lg-12 control-wrappers'>
            <div id='default'>
              <AutoCompleteComponent id="games" dataSource={this.sportsData} ref={(AutoComplete) => { this.listObj = AutoComplete }} placeholder="e.g. Basketball" />
            </div>
          </div>
        </div>        
      </div>
    );
  }
}

React AutoComplete with data binding

Data binding

You can bind data from different types of data sources, such as an array of primitive data, JSON data collections, or remote data sources using adaptors such as OData, OData V4, URL, JSON, and Web API. Data binding uses our data manager to manage data, and also has customization options for data requests and processing.


Filtering

The built-in filtering support includes a rich set of filtering options that is available to meet all your application needs.

React AutoComplete with Filter type

Filter type

Filter data based on starts with, ends with, and contains predicates.

React AutoComplete with Custom filtering

Custom filtering

You can customize the built-in filter query or use your own custom filter libraries to populate data.

React AutoComplete with Diacritic-sensitive search

The React AutoComplete supports diacritic-sensitive searching. This behavior can be turned on or off.

React AutoComplete with Limit suggestion items

Limit suggestion items

Limit the number of suggestions to be displayed in the filtered data list.

React AutoComplete with Ignore filter text casing

Ignore filter text casing

You can filter data with or without case sensitivity.

React AutoComplete with Minimum filter characters length

Minimum filter characters

Set the filter length to begin filtering and populating the data.


Highlight matched text

You can configure different visual appearances for the matching text of each suggestion.

React AutoComplete with Highlight matched text


React Search AutoComplete or Autofill Search

The React AutoComplete component has an autofill search option that completes the word that the user types based on the suggestion text, allowing the user to search for items easily.


Grouping

The React AutoComplete component allows users to see the listed items grouped in categories with individual headers.

React AutoComplete with Grouping


UI customization

Customize the appearance of the AutoComplete suggestion list using templates.

React AutoComplete with Item template

Item template

Define a custom appearance for each suggestion item by using item templates.

React AutoComplete with Header template in suggestion list

Header template

Design a header for the suggestion list using the header template.

React AutoComplete with Footer template in suggestion list

Design a custom footer for the suggestion list using the footer template.

React AutoComplete with Icons in suggestion list

Icons

Add icons to each suggestion item, like countries with flag icons.

React AutoComplete with Empty record template in suggestion list

Empty record

Provide a custom message with a custom appearance when there are no search suggestions to display.


Suggestion list

Generate a suggestion list in the dropdown of the react material autocomplete for users as they type in the input textbox.

React AutoComplete with Dimension customization

Dimension customization

The width and height of the suggestion list is adjustable.

React AutoComplete with Hide or avoid suggestion list

Hide or avoid suggestion list

Hide the default suggestion list and bind the search result onto some other component, such as a data grid.


React AutoComplete with Floating label

Floating label

Developers can control whether the placeholder should float or not.


Mobile-friendly, responsive UI

Provides a responsive mode that displays an adaptive redesigned UI for mobile devices that recognizes touch gestures.



Web accessibility

  • Fully supports WAI-ARIA accessibility standards that make the AutoComplete component accessible to screen readers and assistive devices.
  • Follows WAI-ARIA best practices for implementing keyboard interaction.
  • Designs the UI visual elements such as foreground color, background color, line spacing, text, and images based on the WCAG 2.0 standard.
  • Supports right-to-left (RTL) text direction for users working with RTL languages like Hebrew, Arabic, or Persian.

Developer-friendly APIs

Developers can customize all UI elements and control their behaviors according to the end user’s requirements using the rich set of client-side APIs.




Other Supported Frameworks

In addition to React, built-in integration is available for these major frameworks.

Discover Syncfusion’s Complete React Component Ecosystem

Explore over 145+ React UI components featuring established, production-ready controls and the latest pure React components built natively for modern web app development.

  • React Components
  • Pure React Components

Frequently Asked Questions

  • High-performance loading and searching for autocomplete suggestions in huge volumes of data.
  • Easy integration with other controls such as the DataGrid for modern web and mobile applications.
  • Built-in support for autofill (auto-suggest), hierarchical data binding, highlighted search, and custom search (fuzzy search).

  • Supports standard Syncfusion themes which include Bootstrap v5 and Tailwind CSS.
  • Display floating labels, templated suggestion list and customizable popup dimension.
  • Highly customizable interface with web accessibility features.

  • One of the best React AutoComplete component in the market that offers a feature-rich UI.
  • Simple configuration and API.

  • Supports all modern browsers.
  • Mobile-touch friendly and responsive.
  • Extensive demos and documentation to learn quickly and get started with React AutoComplete.

You can find our React AutoComplete demo, which demonstrates how to render and configure the AutoComplete.

No, this is a commercial product and requires a paid license. However, a free community license is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue, 5 or fewer developers, and 10 or fewer total employees.

A good place to start would be our comprehensive getting started documentation.

Our Customers Love Us

Having an excellent set of tools and a great support team, Syncfusion® reduces customers’ development time.
Here are some of their experiences.

See Real Success Stories

Developers around the world trust Syncfusion’s Essential Studio to simplify complex projects and speed up delivery. With a vast library of UI controls, powerful SDKs, and reliable support, Essential Studio helps teams build enterprise-ready applications with confidence.

Read Our Customer Stories


Rated by users across the globe

Transform your applications today by downloading our free evaluation version
Download Free Trial No credit card required.

Awards

Greatness—it’s one thing to say you have it, but it means more when others recognize it. Syncfusion® is proud to hold the following industry awards.

Up arrow icon

Syncfusion Feedback

Trusted by the world’s leading companies

syncfusion trusted companies

Overview

The Angular Autocomplete is a textbox or search box component that provides a list of suggestions to select from as the user types. It has several out-of-the-box features such as data binding, filtering, grouping, autocomplete search, UI customization, accessibility, and more.


Angular AutoComplete with data binding

Data binding

You can bind data from different types of data sources, such as an array of primitive data, JSON data collections, or remote data sources using adaptors such as OData, OData V4, URL, JSON, and Web API. Data binding uses our data manager to manage data, and also has customization options for data requests and processing.


Filtering

The built-in filtering support includes a rich set of filtering options that is available to meet all your application needs.

Angular AutoComplete with Filter type

Filter type

Filter data based on starts with, ends with, and contains predicates.

Angular AutoComplete with Custom filtering

Custom filtering

You can customize the built-in filter query or use your own custom filter libraries to populate data.

Angular AutoComplete with Diacritic-sensitive search

The Angular AutoComplete Dropdown component supports diacritic-sensitive searching. This behavior can be turned on or off.

Angular AutoComplete Dropdown with Limit suggestion items

Limit suggestion items

Limit the number of suggestions to be displayed in the filtered data list.

Angular AutoComplete with Ignore filter text casing

Ignore filter text casing

You can filter data with or without case sensitivity.

Angular AutoComplete with Minimum filter characters length

Minimum filter characters

Set the filter length to begin filtering and populating the data.


Highlight matched text

You can configure different visual appearances for the matching text of each suggestion.

Angular AutoComplete with Highlight matched text


Angular AutoComplete with Autofill Search

The Angular AutoComplete component has an autofill search option that completes the word that the user types based on the suggestion text, allowing the user to search for items easily.


Grouping

The AutoComplete component allows users to see the listed items grouped in categories with individual headers.

Angular AutoComplete with Grouping


UI customization

Customize the appearance of the AutoComplete suggestion list using templates.

Angular AutoComplete with Item template

Item template

Define a custom appearance for each suggestion item by using item templates.

Angular AutoComplete with Header template in suggestion list

Header template

Design a header for the suggestion list using the header template.

Angular AutoComplete with Footer template in suggestion list

Design a custom footer for the suggestion list using the footer template.

Angular AutoComplete with Icons in suggestion list

Icons

Add icons to each suggestion item, like countries with flag icons.

Angular AutoComplete with Empty record template in suggestion list

Empty record

Provide a custom message with a custom appearance when there are no search suggestions to display.


Suggestion list

Generate a suggestion list in the dropdown of the angular material autocomplete for users as they type in the input textbox.

Dimension customization in Angular AutoComplete input textbox

Dimension customization

The width and height of the suggestion list is adjustable.

Angular AutoComplete Dropdown with Hide or avoid suggestion list

Hide or avoid suggestion list

Hide the default suggestion list and bind the search result onto some other component, such as a data grid.


Angular AutoComplete input with Floating label

Floating label

Developers can control whether the placeholder should float or not.


Forms support

Seamlessly supports HTML5 forms, Angular template-driven forms, and Angular reactive forms.

Mobile-friendly, responsive UI

Provides a responsive mode that displays an adaptive redesigned UI for mobile devices that recognizes touch gestures.


Web accessibility

  • Fully supports WAI-ARIA accessibility standards that make the AutoComplete component accessible to screen readers and assistive devices.
  • Follows WAI-ARIA best practices for implementing keyboard interaction.
  • Designs the UI visual elements such as foreground color, background color, line spacing, text, and images based on the WCAG 2.0 standard.
  • Supports right-to-left (RTL) text direction for users working with RTL languages like Hebrew, Arabic, or Persian.

Developer-friendly APIs

Developers can customize all UI elements and control their behaviors according to the end user’s requirements using the rich set of client-side APIs.


Angular AutoComplete Code Example

Easily get started with the Angular AutoComplete using a few simple lines of HTML and TS code example as demonstrated below. Also explore our Angular AutoComplete Example that shows you how to render and configure a AutoComplete in Angular.

<div class="control-section">
  <ejs-autocomplete id='atcelement'></ejs-autocomplete>
</div>
import { Component } from '@angular/core';

@Component({
    selector: 'app-root',
    // specifies the template string for the AutoComplete component
    template: `<ejs-autocomplete id='atcelement' [dataSource]='sportsData'></ejs-autocomplete>`
})
export class AppComponent {
    constructor() {
    }
    // defined the array of data
    public sportsData: string[] = ['Badminton', 'Basketball', 'Cricket', 'Football', 'Golf', 'Gymnastics', 'Hockey', 'Rugby', 'Snooker', 'Tennis'];
}

Other supported frameworks

AutoComplete is also available in Blazor, React, Vue, and JavaScript frameworks. Check out the different AutoComplete platforms from the links below,




145+ ANGULAR UI COMPONENTS

Frequently Asked Questions

The Syncfusion Angular AutoComplete with rich UI offers the below features:

  • High-performance loading and searching for autocomplete suggestions in huge volumes of data.
  • Easy integration with other controls such as the DataGrid for modern web and mobile applications.
  • Built-in support for autofill (auto-suggest), hierarchical data binding, highlighted search, and custom search (fuzzy search).

  • Supports standard Syncfusion themes which include Bootstrap v5 and Tailwind CSS.
  • Display floating labels, templated suggestion list and customizable popup dimension.
  • Highly customizable interface with web accessibility features.

  • One of the best Angular AutoComplete component in the market that offers a feature-rich UI to interact with the software.
  • Simple configuration and API.

  • Supports all modern browsers.
  • Mobile-touch friendly and responsive.
  • Extensive demos and documentation to learn quickly and get started with Angular AutoComplete

You can find our Angular AutoComplete demo here.

No, this is a commercial product and requires a paid license. However, a free community license is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue, 5 or fewer developers, and 10 or fewer total employees.

A good place to start would be our comprehensive getting started documentation.

Our Customers Love Us

Having an excellent set of tools and a great support team, Syncfusion® reduces customers’ development time.
Here are some of their experiences.

See Real Success Stories

Developers around the world trust Syncfusion’s Essential Studio to simplify complex projects and speed up delivery. With a vast library of UI controls, powerful SDKs, and reliable support, Essential Studio helps teams build enterprise-ready applications with confidence.

Read Our Customer Stories


Rated by users across the globe

Transform your applications today by downloading our free evaluation version
Download Free Trial No credit card required.

Awards

Greatness—it’s one thing to say you have it, but it means more when others recognize it. Syncfusion® is proud to hold the following industry awards.

Up arrow icon